=== debian/control ===
Source: eiskaltdcpp
Section: net
Priority: optional
Maintainer: Boris Pek <tehnick@debian.org>
Build-Depends: cmake,
               debhelper (>= 11~),
               libaspell-dev,
               libattr1-dev,
               libboost-dev,
               libboost-system-dev,
               libbz2-dev,
               libglade2-dev,
               libgtk2.0-dev,
               libidn11-dev,
               liblua5.1-0-dev,
               libminiupnpc-dev,
               libnotify-dev,
               libpcre3-dev,
               libqt5xmlpatterns5-dev,
               libssl-dev,
               pkg-config,
               po-debconf,
               qtbase5-dev,
               qtmultimedia5-dev,
               qtscript5-dev,
               qttools5-dev,
               qttools5-dev-tools,
               zlib1g-dev
Homepage: https://github.com/eiskaltdcpp/eiskaltdcpp
Vcs-Git: https://github.com/tehnick/eiskaltdcpp-debian.git
Vcs-Browser: https://github.com/tehnick/eiskaltdcpp-debian
Standards-Version: 4.1.3

Package: eiskaltdcpp
Section: metapackages
Architecture: all
Depends: eiskaltdcpp-emoticons,
         eiskaltdcpp-qt | eiskaltdcpp-gtk,
         eiskaltdcpp-scripts,
         eiskaltdcpp-sounds,
         ${misc:Depends}
Description: EiskaltDC++ metapackage
 This package installs the most popular and recommended combination of
 EiskaltDC++ related packages.
 .
 EiskaltDC++ is a cross-platform program that uses the Direct Connect and ADC
 protocols. It is compatible with DC++, FlylinkDC++, LinuxDC++ and other DC
 clients. EiskaltDC++ also interoperates with all common DC hub software.

Package: eiskaltdcpp-common
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: common files for EiskaltDC++
 This package contains the common files for the different EiskaltDC++ versions.
 .
 EiskaltDC++ is a cross-platform program that uses the Direct Connect and ADC
 protocols. It is compatible with DC++, FlylinkDC++, LinuxDC++ and other DC
 clients. EiskaltDC++ also interoperates with all common DC hub software.

Package: eiskaltdcpp-emoticons
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: emoticons for EiskaltDC++
 This package contains the emoticon packs for EiskaltDC++.
 .
 EiskaltDC++ is a cross-platform program that uses the Direct Connect and ADC
 protocols. It is compatible with DC++, FlylinkDC++, LinuxDC++ and other DC
 clients. EiskaltDC++ also interoperates with all common DC hub software.

Package: eiskaltdcpp-scripts
Architecture: all
Depends: ${misc:Depends}
Recommends: php-cli
Multi-Arch: foreign
Description: scripts examples for EiskaltDC++
 This package contains the scripts examples for EiskaltDC++.
 It used by /sh and /alias chat commands (see man-page or /help in chat).
 .
 EiskaltDC++ is a cross-platform program that uses the Direct Connect and ADC
 protocols. It is compatible with DC++, FlylinkDC++, LinuxDC++ and other DC
 clients. EiskaltDC++ also interoperates with all common DC hub software.

Package: eiskaltdcpp-sounds
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: sound files for EiskaltDC++
 This package contains the sound files for EiskaltDC++.
 .
 EiskaltDC++ is a cross-platform program that uses the Direct Connect and ADC
 protocols. It is compatible with DC++, FlylinkDC++, LinuxDC++ and other DC
 clients. EiskaltDC++ also interoperates with all common DC hub software.

Package: libeiskaltdcpp2.4
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Replaces: libeiskaltdcpp2.2
Breaks: libeiskaltdcpp2.2
Multi-Arch: no
Description: DC++ kernel library from EiskaltDC++
 This package installs only DC++ kernel library which required EiskaltDC++.
 .
 EiskaltDC++ is a cross-platform program that uses the Direct Connect and ADC
 protocols. It is compatible with DC++, FlylinkDC++, LinuxDC++ and other DC
 clients. EiskaltDC++ also interoperates with all common DC hub software.

Package: libeiskaltdcpp-dev
Section: libdevel
Architecture: any
Depends: libeiskaltdcpp2.4 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: no
Description: DC++ kernel from EiskaltDC++ (development files)
 This package contains header files for EiskaltDC++ kernel library.
 .
 EiskaltDC++ is a cross-platform program that uses the Direct Connect and ADC
 protocols. It is compatible with DC++, FlylinkDC++, LinuxDC++ and other DC
 clients. EiskaltDC++ also interoperates with all common DC hub software.

Package: eiskaltdcpp-qt
Architecture: any
Depends: eiskaltdcpp-common,
         eiskaltdcpp-qt-data (= ${source:Version}),
         libqt5sql5-sqlite,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: libqt5script5,
            libqt5scripttools5
Provides: eiskaltdcpp-qt-mini
Replaces: eiskaltdcpp-qt-mini
Conflicts: eiskaltdcpp-qt-mini
Description: EiskaltDC++ GUI based on Qt
 This package installs only EiskaltDC++ with GUI based on Qt.
 .
 EiskaltDC++ is a cross-platform program that uses the Direct Connect and ADC
 protocols. It is compatible with DC++, FlylinkDC++, LinuxDC++ and other DC
 clients. EiskaltDC++ also interoperates with all common DC hub software.

Package: eiskaltdcpp-qt-data
Architecture: all
Depends: ${misc:Depends}
Suggests: eiskaltdcpp-emoticons,
          eiskaltdcpp-scripts,
          eiskaltdcpp-sounds,
          php-cli
Multi-Arch: foreign
Description: data files for EiskaltDC++ Qt
 This package contains the data files for EiskaltDC++ Qt.
 .
 EiskaltDC++ is a cross-platform program that uses the Direct Connect and ADC
 protocols. It is compatible with DC++, FlylinkDC++, LinuxDC++ and other DC
 clients. EiskaltDC++ also interoperates with all common DC hub software.

Package: eiskaltdcpp-gtk
Architecture: any
Depends: eiskaltdcpp-common,
         eiskaltdcpp-gtk-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Provides: eiskaltdcpp-gtk3
Replaces: eiskaltdcpp-gtk3
Conflicts: eiskaltdcpp-gtk3
Description: EiskaltDC++ GUI based on GTK+
 This package installs only EiskaltDC++ with GUI based on Gtk (based on
 FreeDC++ and LinuxDC++ projects).
 .
 EiskaltDC++ is a cross-platform program that uses the Direct Connect and ADC
 protocols. It is compatible with DC++, FlylinkDC++, LinuxDC++ and other DC
 clients. EiskaltDC++ also interoperates with all common DC hub software.

Package: eiskaltdcpp-gtk-data
Architecture: all
Depends: ${misc:Depends}
Suggests: eiskaltdcpp-emoticons,
          eiskaltdcpp-scripts,
          eiskaltdcpp-sounds,
          php-cli
Multi-Arch: foreign
Description: data files for EiskaltDC++ Gtk
 This package contains the data files for EiskaltDC++ Gtk.
 .
 EiskaltDC++ is a cross-platform program that uses the Direct Connect and ADC
 protocols. It is compatible with DC++, FlylinkDC++, LinuxDC++ and other DC
 clients. EiskaltDC++ also interoperates with all common DC hub software.

Package: eiskaltdcpp-daemon
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: eiskaltdcpp-cli
Description: EiskaltDC++ daemon
 This package installs only EiskaltDC++ daemon (without any GUI).
 Support of control via JSON-RPC is enabled.
 .
 EiskaltDC++ is a cross-platform program that uses the Direct Connect and ADC
 protocols. It is compatible with DC++, FlylinkDC++, LinuxDC++ and other DC
 clients. EiskaltDC++ also interoperates with all common DC hub software.

Package: eiskaltdcpp-cli
Architecture: all
Depends: libdata-dump-perl,
         libgetopt-long-descriptive-perl,
         libjson-rpc-perl,
         libterm-shellui-perl,
         ${misc:Depends},
         ${perl:Depends}
Suggests: eiskaltdcpp-daemon
Description: EiskaltDC++ command-line interface
 This package installs EiskaltDC++ CLI (command-line interface) written in perl.
 This program is to control eiskaltdcpp-daemon via JSON-RPC protocol.
 .
 EiskaltDC++ is a cross-platform program that uses the Direct Connect and ADC
 protocols. It is compatible with DC++, FlylinkDC++, LinuxDC++ and other DC
 clients. EiskaltDC++ also interoperates with all common DC hub software.
