=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk

PACKAGE = eiskaltdcpp

DEBIAN_PATH := $(abspath $(dir $(MAKEFILE_LIST)))
USCAN_REPORT = $(shell uscan --noconf --report --dehs "$(DEBIAN_PATH)")
CUR_VER = $(shell echo "$(USCAN_REPORT)" | sed -n 's/.*<upstream-version>\(.*\)<\/upstream-version>.*/\1/p')
CUR_URL = $(shell echo "$(USCAN_REPORT)" | sed -n 's/.*<upstream-url>\(.*\)<\/upstream-url>.*/\1/p')

export DEB_CXXFLAGS_MAINT_APPEND = $(shell dpkg-buildflags --get CPPFLAGS)
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CMAKEOPTS = -DUSE_MINIUPNP=ON \
            -DLOCAL_MINIUPNP=OFF \
            -DLUA_SCRIPT=ON \
            -DWITH_LUASCRIPTS=ON \
            -DPERL_REGEX=ON \
            -DWITH_DHT=ON \
            -DUSE_IDNA=ON \
            -DWITH_SOUNDS=ON \
            -DUSE_QT5=ON \
            -DUSE_QT=OFF \
            -DUSE_QT_SQLITE=ON \
            -DUSE_JS=ON \
            -DUSE_QT_QML=OFF \
            -DUSE_ASPELL=ON \
            -DFREE_SPACE_BAR_C=ON \
            -DUSE_GTK3=OFF \
            -DUSE_GTK=ON \
            -DCHECK_GTK_DEPRECATED=OFF \
            -DUSE_LIBGNOME2=OFF \
            -DUSE_LIBNOTIFY=ON \
            -DCREATE_MO=ON \
            -DUPDATE_PO=OFF \
            -DNO_UI_DAEMON=ON \
            -DXMLRPC_DAEMON=OFF \
            -DJSONRPC_DAEMON=ON \
            -DUSE_CLI_JSONRPC=ON \
            -DWITH_DEV_FILES=ON \
            -DREPLACE_VERSION="$(DEB_VERSION_UPSTREAM)"


%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKEOPTS)

get-orig-source:
	wget -c "$(CUR_URL)" -O "$(PACKAGE)_$(CUR_VER).orig.tar.xz"
