=== debian/watch ===
version=3
http://sf.net/eiskaltdcpp/eiskaltdcpp-(.+)\.tar\.xz \
debian uupdate
